OGG几何内核-BRepBuilderAPI_MakeEdge学习

2024-05-24 02:12

本文主要是介绍OGG几何内核-BRepBuilderAPI_MakeEdge学习,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

OGG几何内核fork自OCCT 7.7.0,

BRepBuilderAPI_MakeEdge是几何内核的一个重要和基础的功能,也十分复杂,因为要支持line、circle、ellipse,parabola,hyperbola,circle,beziercurve,bsplinecurve。需要支持多种参数情况:

1、曲线。

2、曲线+始终长度。

3、曲线+始终角度。

4、曲线+两点。

5、曲线+面。

代码注释如下:

Provides methods to build edges.

The   methods have  the  following   syntax, where TheCurve is one of Lin, Circ, ...

Create(C : TheCurve)

Makes an edge on  the whole curve.  Add vertices on finite curves.

Create(C : TheCurve; p1,p2 : Real)

Make an edge  on the curve between parameters p1 and p2. if p2 < p1 the edge will be REVERSED. If p1  or p2 is infinite the  curve will be open in that  direction. Vertices are created for finite values of p1 and p2.

Create(C : TheCurve; P1, P2 : Pnt from gp)

Make an edge on the curve  between the points P1 and P2. The  points are projected on   the curve and the   previous method is  used. An  error is raised if the points are not on the curve.

Create(C : TheCurve; V1, V2 : Vertex from TopoDS)

Make an edge  on the curve  between the vertices V1 and V2. Same as the  previous but no vertices are created. If a vertex is  Null the curve will be open in this direction.

class BRepBuilderAPI_MakeEdge  : public BRepBuilderAPI_MakeShape
{
public:DEFINE_STANDARD_ALLOCStandard_EXPORT BRepBuilderAPI_MakeEdge();Standard_EXPORT BRepBuilderAPI_MakeEdge(const TopoDS_Vertex& V1, const TopoDS_Vertex& V2);Standard_EXPORT BRepBuilderAPI_MakeEdge(const gp_Pnt& P1, const gp_Pnt& P2);Standard_EXPORT BRepBuilderAPI_MakeEdge(const gp_Lin& L);Standard_EXPORT BRepBuilderAPI_MakeEdge(const gp_Lin& L, const Standard_Real p1, const Standard_Real p2);Standard_EXPORT BRepBuilderAPI_MakeEdge(const gp_Lin& L, const gp_Pnt& P1, const gp_Pnt& P2);Standard_EXPORT BRepBuilderAPI_MakeEdge(const gp_Lin& L, const TopoDS_Vertex& V1, const TopoDS_Vertex& V2);Standard_EXPORT BRepBuilderAPI_MakeEdge(const gp_Circ& L);Standard_EXPORT BRepBuilderAPI_MakeEdge(const gp_Circ& L, const Standard_Real p1, const Standard_Real p2);Standard_EXPORT BRepBuilderAPI_MakeEdge(const gp_Circ& L, const gp_Pnt& P1, const gp_Pnt& P2);Standard_EXPORT BRepBuilderAPI_MakeEdge(const gp_Circ& L, const TopoDS_Vertex& V1, const TopoDS_Vertex& V2);Standard_EXPORT BRepBuilderAPI_MakeEdge(const gp_Elips& L);Standard_EXPORT BRepBuilderAPI_MakeEdge(const gp_Elips& L, const Standard_Real p1, const Standard_Real p2);Standard_EXPORT BRepBuilderAPI_MakeEdge(const gp_Elips& L, const gp_Pnt& P1, const gp_Pnt& P2);Standard_EXPORT BRepBuilderAPI_MakeEdge(const gp_Elips& L, const TopoDS_Vertex& V1, const TopoDS_Vertex& V2);Standard_EXPORT BRepBuilderAPI_MakeEdge(const gp_Hypr& L);Standard_EXPORT BRepBuilderAPI_MakeEdge(const gp_Hypr& L, const Standard_Real p1, const Standard_Real p2);Standard_EXPORT BRepBuilderAPI_MakeEdge(const gp_Hypr& L, const gp_Pnt& P1, const gp_Pnt& P2);Standard_EXPORT BRepBuilderAPI_MakeEdge(const gp_Hypr& L, const TopoDS_Vertex& V1, const TopoDS_Vertex& V2);Standard_EXPORT BRepBuilderAPI_MakeEdge(const gp_Parab& L);Standard_EXPORT BRepBuilderAPI_MakeEdge(const gp_Parab& L, const Standard_Real p1, const Standard_Real p2);Standard_EXPORT BRepBuilderAPI_MakeEdge(const gp_Parab& L, const gp_Pnt& P1, const gp_Pnt& P2);Standard_EXPORT BRepBuilderAPI_MakeEdge(const gp_Parab& L, const TopoDS_Vertex& V1, const TopoDS_Vertex& V2);Standard_EXPORT BRepBuilderAPI_MakeEdge(const Handle(Geom_Curve)& L);Standard_EXPORT BRepBuilderAPI_MakeEdge(const Handle(Geom_Curve)& L, const Standard_Real p1, const Standard_Real p2);Standard_EXPORT BRepBuilderAPI_MakeEdge(const Handle(Geom_Curve)& L, const gp_Pnt& P1, const gp_Pnt& P2);Standard_EXPORT BRepBuilderAPI_MakeEdge(const Handle(Geom_Curve)& L, const TopoDS_Vertex& V1, const TopoDS_Vertex& V2);Standard_EXPORT BRepBuilderAPI_MakeEdge(const Handle(Geom_Curve)& L, const gp_Pnt& P1, const gp_Pnt& P2, const Standard_Real p1, const Standard_Real p2);Standard_EXPORT BRepBuilderAPI_MakeEdge(const Handle(Geom_Curve)& L, const TopoDS_Vertex& V1, const TopoDS_Vertex& V2, const Standard_Real p1, const Standard_Real p2);Standard_EXPORT BRepBuilderAPI_MakeEdge(const Handle(Geom2d_Curve)& L, const Handle(Geom_Surface)& S);Standard_EXPORT BRepBuilderAPI_MakeEdge(const Handle(Geom2d_Curve)& L, const Handle(Geom_Surface)& S, const Standard_Real p1, const Standard_Real p2);Standard_EXPORT BRepBuilderAPI_MakeEdge(const Handle(Geom2d_Curve)& L, const Handle(Geom_Surface)& S, const gp_Pnt& P1, const gp_Pnt& P2);Standard_EXPORT BRepBuilderAPI_MakeEdge(const Handle(Geom2d_Curve)& L, const Handle(Geom_Surface)& S, const TopoDS_Vertex& V1, const TopoDS_Vertex& V2);Standard_EXPORT BRepBuilderAPI_MakeEdge(const Handle(Geom2d_Curve)& L, const Handle(Geom_Surface)& S, const gp_Pnt& P1, const gp_Pnt& P2, const Standard_Real p1, const Standard_Real p2);//! The general method to directly create an edge is to give//! -      a 3D curve C as the support (geometric domain) of the edge,//! -      two vertices V1 and V2 to limit the curve (definition of the restriction of//! the edge), and//! -      two real values p1 and p2 which are the parameters for the vertices V1 and V2//! on the curve.//! The curve may be defined as a 2d curve in the parametric space of a surface: a//! pcurve. The surface on which the edge is built is then kept at the level of the edge.//! The default tolerance will be associated with this edge.//! Rules applied to the arguments://! For the curve://! -      The curve must not be a 'null handle'.//! -      If the curve is a trimmed curve the basis curve is used.//! For the vertices://! -      Vertices may be null shapes. When V1 or V2 is null the edge is open in the//! corresponding direction and the parameter value p1 or p2 must be infinite//! (remember that Precision::Infinite() defines an infinite value).//! -      The two vertices must be identical if they have the same 3D location.//! Identical vertices are used in particular when the curve is closed.//! For the parameters://! -      The parameters must be in the parametric range of the curve (or the basis//! curve if the curve is trimmed). If this condition is not satisfied the edge is not//! built, and the Error function will return BRepAPI_ParameterOutOfRange.//! -      Parameter values must not be equal. If this condition is not satisfied (i.e.//! if | p1 - p2 | ) the edge is not built, and the Error function will return//! BRepAPI_LineThroughIdenticPoints.//! Parameter values are expected to be given in increasing order://! C->FirstParameter()//! - If the parameter values are given in decreasing order the vertices are switched,//! i.e. the "first vertex" is on the point of parameter p2 and the "second vertex" is//! on the point of parameter p1. In such a case, to keep the original intent of the//! construction, the edge will be oriented "reversed".//! - On a periodic curve the parameter values p1 and p2 are adjusted by adding or//! subtracting the period to obtain p1 in the parametric range of the curve, and p2]//! such that [ p1 , where Period is the period of the curve.//! - A parameter value may be infinite. The edge is open in the corresponding//! direction. However the corresponding vertex must be a null shape. If this condition//! is not satisfied the edge is not built, and the Error function will return//! BRepAPI_PointWithInfiniteParameter.//! - The distance between the vertex and the point evaluated on the curve with the//! parameter, must be lower than the precision of the vertex. If this condition is not//! satisfied the edge is not built, and the Error function will return//! BRepAPI_DifferentsPointAndParameter.//! Other edge constructions//! - The parameter values can be omitted, they will be computed by projecting the//! vertices on the curve. Note that projection is the only way to evaluate the//! parameter values of the vertices on the curve: vertices must be given on the curve,//! i.e. the distance from a vertex to the curve must be less than or equal to the//! precision of the vertex. If this condition is not satisfied the edge is not built,//! and the Error function will return BRepAPI_PointProjectionFailed.//! -      3D points can be given in place of vertices. Vertices will be created from the//! points (with the default topological precision Precision::Confusion()).//! Note://! -      Giving vertices is useful when creating a connected edge.//! -      If the parameter values correspond to the extremities of a closed curve,//! points must be identical, or at least coincident. If this condition is not//! satisfied the edge is not built, and the Error function will return//! BRepAPI_DifferentPointsOnClosedCurve.//! -      The vertices or points can be omitted if the parameter values are given. The//! points will be computed from the parameters on the curve.//! The vertices or points and the parameter values can be omitted. The first and last//! parameters of the curve will then be used.//!//! Auxiliary methodsStandard_EXPORT BRepBuilderAPI_MakeEdge(const Handle(Geom2d_Curve)& L, const Handle(Geom_Surface)& S, const TopoDS_Vertex& V1, const TopoDS_Vertex& V2, const Standard_Real p1, const Standard_Real p2);Standard_EXPORT void Init (const Handle(Geom_Curve)& C);Standard_EXPORT void Init (const Handle(Geom_Curve)& C, const Standard_Real p1, const Standard_Real p2);Standard_EXPORT void Init (const Handle(Geom_Curve)& C, const gp_Pnt& P1, const gp_Pnt& P2);Standard_EXPORT void Init (const Handle(Geom_Curve)& C, const TopoDS_Vertex& V1, const TopoDS_Vertex& V2);Standard_EXPORT void Init (const Handle(Geom_Curve)& C, const gp_Pnt& P1, const gp_Pnt& P2, const Standard_Real p1, const Standard_Real p2);Standard_EXPORT void Init (const Handle(Geom_Curve)& C, const TopoDS_Vertex& V1, const TopoDS_Vertex& V2, const Standard_Real p1, const Standard_Real p2);Standard_EXPORT void Init (const Handle(Geom2d_Curve)& C, const Handle(Geom_Surface)& S);Standard_EXPORT void Init (const Handle(Geom2d_Curve)& C, const Handle(Geom_Surface)& S, const Standard_Real p1, const Standard_Real p2);Standard_EXPORT void Init (const Handle(Geom2d_Curve)& C, const Handle(Geom_Surface)& S, const gp_Pnt& P1, const gp_Pnt& P2);Standard_EXPORT void Init (const Handle(Geom2d_Curve)& C, const Handle(Geom_Surface)& S, const TopoDS_Vertex& V1, const TopoDS_Vertex& V2);Standard_EXPORT void Init (const Handle(Geom2d_Curve)& C, const Handle(Geom_Surface)& S, const gp_Pnt& P1, const gp_Pnt& P2, const Standard_Real p1, const Standard_Real p2);//! Defines or redefines the arguments for the construction of an edge.//! This function is currently used after the empty constructor BRepAPI_MakeEdge().Standard_EXPORT void Init (const Handle(Geom2d_Curve)& C, const Handle(Geom_Surface)& S, const TopoDS_Vertex& V1, const TopoDS_Vertex& V2, const Standard_Real p1, const Standard_Real p2);protected:private:BRepLib_MakeEdge myMakeEdge;};

从最后几行代码,结合可以发现,BRepBuilderAPI_MakeEdge是BRepLib_MakeEdge的包装,实际功能由BRepLib_MakeEdge实现。

为了能更深入理解BRepBuilderAPI_MakeEdge,可以研究分析一下测试命令mkedge的代码。

static Standard_Integer mkedge(Draw_Interpretor& di, Standard_Integer n, const char** a)
{if (n < 3) return 1;Handle(Geom_Curve)   C   = DrawTrSurf::GetCurve(a[2]);Handle(Geom2d_Curve) C2d = DrawTrSurf::GetCurve2d(a[2]);if (C.IsNull() && C2d.IsNull()) {//std::cout << a[2] << " is not a curve" << std::endl;di << a[2] << " is not a curve\n";return 1;}TopoDS_Edge edge;if (n == 3) {if (!C.IsNull())   edge = BRepBuilderAPI_MakeEdge(C);else               edge = BRepBuilderAPI_MakeEdge2d(C2d);}else {Handle(Geom_Surface) S;Standard_Integer i = 0;if (!C2d.IsNull()) {S = DrawTrSurf::GetSurface(a[3]);if (!S.IsNull()) i = 1;}TopoDS_Shape aLocalShape(DBRep::Get(a[3+i],TopAbs_VERTEX));TopoDS_Vertex V1 = TopoDS::Vertex(aLocalShape);
//    TopoDS_Vertex V1 = TopoDS::Vertex(DBRep::Get(a[3+i],TopAbs_VERTEX));if (n == 5+i) {if (V1.IsNull()) {if (!C.IsNull())   edge = BRepBuilderAPI_MakeEdge(C,Draw::Atof(a[3]),Draw::Atof(a[4]));else if (S.IsNull())              edge = BRepBuilderAPI_MakeEdge2d(C2d,Draw::Atof(a[3]),Draw::Atof(a[4]));elseedge = BRepBuilderAPI_MakeEdge(C2d,S,Draw::Atof(a[4]),Draw::Atof(a[5]));}else {aLocalShape = DBRep::Get(a[4+i],TopAbs_VERTEX);TopoDS_Vertex V2 = TopoDS::Vertex(aLocalShape);
//  TopoDS_Vertex V2 = TopoDS::Vertex(DBRep::Get(a[4+i],TopAbs_VERTEX));if (!C.IsNull())   edge = BRepBuilderAPI_MakeEdge(C,V1,V2);else if (S.IsNull())              edge = BRepBuilderAPI_MakeEdge2d(C2d,V1,V2);elseedge = BRepBuilderAPI_MakeEdge(C2d,S,V1,V2);}}  else if (n == 7+i) {aLocalShape = DBRep::Get(a[5+i],TopAbs_VERTEX);TopoDS_Vertex V2 = TopoDS::Vertex(aLocalShape);
//      TopoDS_Vertex V2 = TopoDS::Vertex(DBRep::Get(a[5+i],TopAbs_VERTEX));if (!C.IsNull())   edge = BRepBuilderAPI_MakeEdge(C,V1,V2,Draw::Atof(a[4]),Draw::Atof(a[6]));else if (S.IsNull())         edge = BRepBuilderAPI_MakeEdge2d(C2d,V1,V2,Draw::Atof(a[4]),Draw::Atof(a[6]));else              edge = BRepBuilderAPI_MakeEdge(C2d,S,V1,V2,Draw::Atof(a[5]),Draw::Atof(a[7]));}elsereturn 1;}DBRep::Set(a[1],edge);return 0;
}

以下是各种曲线生成及参数测试:

vertex a 0 0 0
vertex b 6 0 0
vertex c 6 1 0
vertex d 6 0 0
edge l a b
mkcurve curve1 l
mkedge l1 curve1 1 2
mkedge l2 curve1 a b
mkedge l3 curve1 a c
mkedge l4 curve1 a dcircle c 0 0 0 10
mkedge c1 c 0 pi/4
mkedge c1 c 0 pi/2
mkedge c1 c 0 pi
mkedge c1 c 0 2*pi
mkedge c1 c 0 2pi
mkedge c1 c -pi pi
mkedge c1 c -pi/2 0mkedge e1 a bparabola w1 0 0 0 1 0 0 0 0 1 50
mkedge p1 w1 -100 100beziercurve w2 5 0 0 0 20 0 0 20 5 0 25 10 0 10 20 0
mkedge b1 w2 
mkedge b1 w2 0 0.5
mkedge b1 w2 0 0.9
mkedge b1 w2 0 1
mkedge b1 w2 0 2bsplinecurve w3 3 2  -1.0 4   1.0 4  0 0 0 1  2 10 0 1  4 6 0 1  10 0 0 1
mkedge b2 w3
mkedge b2 w3  0 0.5

通过这些测试命令,可以观察看到线的方向,以及OCCT对不同类型的线生成的edge的处理方式不同。

抛物线和双曲线:

beziercurve和bsplinecurve

这篇关于OGG几何内核-BRepBuilderAPI_MakeEdge学习的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/997076

相关文章

Linux内核之内核裁剪详解

《Linux内核之内核裁剪详解》Linux内核裁剪是通过移除不必要的功能和模块,调整配置参数来优化内核,以满足特定需求,裁剪的方法包括使用配置选项、模块化设计和优化配置参数,图形裁剪工具如makeme... 目录简介一、 裁剪的原因二、裁剪的方法三、图形裁剪工具四、操作说明五、make menuconfig

如何安装HWE内核? Ubuntu安装hwe内核解决硬件太新的问题

《如何安装HWE内核?Ubuntu安装hwe内核解决硬件太新的问题》今天的主角就是hwe内核(hardwareenablementkernel),一般安装的Ubuntu都是初始内核,不能很好地支... 对于追求系统稳定性,又想充分利用最新硬件特性的 Ubuntu 用户来说,HWEXBQgUbdlna(Har

HarmonyOS学习(七)——UI(五)常用布局总结

自适应布局 1.1、线性布局(LinearLayout) 通过线性容器Row和Column实现线性布局。Column容器内的子组件按照垂直方向排列,Row组件中的子组件按照水平方向排列。 属性说明space通过space参数设置主轴上子组件的间距,达到各子组件在排列上的等间距效果alignItems设置子组件在交叉轴上的对齐方式,且在各类尺寸屏幕上表现一致,其中交叉轴为垂直时,取值为Vert

Ilya-AI分享的他在OpenAI学习到的15个提示工程技巧

Ilya(不是本人,claude AI)在社交媒体上分享了他在OpenAI学习到的15个Prompt撰写技巧。 以下是详细的内容: 提示精确化:在编写提示时,力求表达清晰准确。清楚地阐述任务需求和概念定义至关重要。例:不用"分析文本",而用"判断这段话的情感倾向:积极、消极还是中性"。 快速迭代:善于快速连续调整提示。熟练的提示工程师能够灵活地进行多轮优化。例:从"总结文章"到"用

【前端学习】AntV G6-08 深入图形与图形分组、自定义节点、节点动画(下)

【课程链接】 AntV G6:深入图形与图形分组、自定义节点、节点动画(下)_哔哩哔哩_bilibili 本章十吾老师讲解了一个复杂的自定义节点中,应该怎样去计算和绘制图形,如何给一个图形制作不间断的动画,以及在鼠标事件之后产生动画。(有点难,需要好好理解) <!DOCTYPE html><html><head><meta charset="UTF-8"><title>06

学习hash总结

2014/1/29/   最近刚开始学hash,名字很陌生,但是hash的思想却很熟悉,以前早就做过此类的题,但是不知道这就是hash思想而已,说白了hash就是一个映射,往往灵活利用数组的下标来实现算法,hash的作用:1、判重;2、统计次数;

内核启动时减少log的方式

内核引导选项 内核引导选项大体上可以分为两类:一类与设备无关、另一类与设备有关。与设备有关的引导选项多如牛毛,需要你自己阅读内核中的相应驱动程序源码以获取其能够接受的引导选项。比如,如果你想知道可以向 AHA1542 SCSI 驱动程序传递哪些引导选项,那么就查看 drivers/scsi/aha1542.c 文件,一般在前面 100 行注释里就可以找到所接受的引导选项说明。大多数选项是通过"_

零基础学习Redis(10) -- zset类型命令使用

zset是有序集合,内部除了存储元素外,还会存储一个score,存储在zset中的元素会按照score的大小升序排列,不同元素的score可以重复,score相同的元素会按照元素的字典序排列。 1. zset常用命令 1.1 zadd  zadd key [NX | XX] [GT | LT]   [CH] [INCR] score member [score member ...]

【机器学习】高斯过程的基本概念和应用领域以及在python中的实例

引言 高斯过程(Gaussian Process,简称GP)是一种概率模型,用于描述一组随机变量的联合概率分布,其中任何一个有限维度的子集都具有高斯分布 文章目录 引言一、高斯过程1.1 基本定义1.1.1 随机过程1.1.2 高斯分布 1.2 高斯过程的特性1.2.1 联合高斯性1.2.2 均值函数1.2.3 协方差函数(或核函数) 1.3 核函数1.4 高斯过程回归(Gauss